/************************ WiFi Sous-vide *************************
   ESP8266 - Sonoff - Wemos mini - or other ESP8266 module 
   by Ewald Kendziorra sr, 2017 www.kendziorra.nl
   Before you start: read the Sous-vide information in "info.txt"
 *****************************************************************/

/** 28YBJ-48 DC 5V 4 Phase 5 Wire Stepper Motor With ULN2003 Driver Board - 4096 steps *
 *                                                                          ====       *
 *  Stepper 2017 by Ewald Kendziorra sr, www.kendziorra.nl                             *
 ***************************************************************************************/

/***********************************************************************
 *  using Stepper:  stepInit(pins[], speed);  // set pins and speed    *
 *    stepper(135);     // turn 135 steps R ( 512 steps = 360*)        *
 *    stepper(-135);    // turn 135 steps L ( 512 steps = 360*)        *
 *    smallSteps(135);  // turn 135 steps R (4096 steps = 360*)        *
 *    smallSteps(-135); // turn 135 steps L (4096 steps = 360*)        *
 ***********************************************************************/

#ifndef STEPPER_H
  #define STEPPER_H
  
  const uint8_t steps[9][4] = {  // 8 steps and one default (steps[8])
                  {0, 0, 0, 1}, {0, 0, 1, 1}, {0, 0, 1, 0}, {0, 1, 1, 0},
                  {0, 1, 0, 0}, {1, 1, 0, 0}, {1, 0, 0, 0}, {1, 0, 0, 1},
    /*default ->*/{0, 0, 0, 0}};/*<- default*/
  uint8_t _in1234[4] = {D5, D6, D7, D8},  // stepper pins on WeMos/NodeMCU/...  (ESP8266 GPIO 14/12/13/15)
          _stepSpeed = 1;  // delay in ms,  default 1, min: 1, max: 10
  
  void stepInit(const uint8_t*, const uint8_t);
  void setSteps(const uint8_t);
  void stepper(int16_t);     // 0- 511 = 360*
  void smallSteps(int16_t);  // 0-4095 = 360*

#endif

