/************************ WiFi Sous-vide *************************
   ESP8266 - Sonoff - Wemos mini - or other ESP8266 module 
   by Ewald Kendziorra sr, 2017 www.kendziorra.nl
   Before you start: read the Sous-vide information in "info.txt"
 *****************************************************************/

#include "SousVidePan.h"

/** start AutoTune **/
void startAutoTune() {
  aTune.SetNoiseBand(aTuneNoise);
  aTune.SetOutputStep(aTuneStep);
  aTune.SetLookbackSec((int)aTuneLookBack);
  aTuneModeRemember = myPID.GetMode();
  tuning = true;
  tuneStart();
}

/** Return to normal control **/
void finishAutoTune() {
  sopids[Kp] = aTune.GetKp();
  sopids[Ki] = aTune.GetKi();
  sopids[Kd] = aTune.GetKd();
  // Re-tune the PID and revert to normal control mode
  myPID.SetTunings(sopids[Kp], sopids[Ki], sopids[Kd]);
  myPID.SetMode(aTuneModeRemember);
  saveParameters();
  tuneStop();
  setInfo();
  strcpy(values[message], "Autotune is ready!");
  strcpy(values[mp3], "ready"); 
  uint8_t n[] = {client, command, message, mp3}; 
  out(n, sizeof(n));
}
