/************************** NewHomeSwitch ***************************
 * Wemos D1 Mini - ESP8266-nn - Sonoff - ????                       *
 * by Ewald Kendziorra sr, 2016 www.kendziorra.nl                   *
 * Before you start: read the NewHomeSwitch information in folder:  *
 * - NHS_info                                                       *
 * - NHS_img                                                        *
 * - NHS_link                                                       *
 * - NHS_HTML                                                       *
 ********************************************************************
 * NHS server module by Ewald Kendziorra sr, 2016                   *
 ********************************************************************/
//##### This is not a real library class module and therefore easy to edit for each slave #####//

/*****************************************
 * simpleDB by Ewald Kendziorra sr, 2016 *
 *****************************************/

#ifndef SIMPLE_DB
#define SIMPLE_DB

File dbF, cpF;  // database, copy/backup

void dbOpen();
void initDb(uint8_t, char const*, char const*);
void nrRec();
boolean findRec(char const*);
int8_t getRec(uint8_t);
int8_t setRec(uint8_t);
void addRec(char const*, char const*);
void writeRec(char const*, char const*);
void wrtRec(char const*, char const*, boolean);
void readRec(char const*);
void delRec(char const*);
void listRec(boolean);
void cmprDb();
void showDbErr();

const uint8_t kyW = 4,          // fixed key width (4 chars)
              tsM = kyW + 1,    // pos. tombstone marker
              nxW = kyW + 3,    // fixed index width (key width + tombstone marker "key|0|")
              dtW = 127,        // max data width in a record, exclusive 'key' and 'tombstone' marker
              dbW = dtW + nxW;  // record width, |key|t|dddd|...|ddd (t=tombstone, ddd..=data, |=delimiter)
uint8_t ssP,                    // Chip Select pi
        dbR,                    // number of records
        mxR = 255;              // max number of records
char dbN[13],                   // database file  // short notation max 8.3 'naaaaame.ext'
     cpN[13],                   // database back-up file
     dbB[dbW],                  // record read buffer
     rBuf[dbW],                 // action record buffer
     dbP[dbW],                  // strcpy(), holder fixed data length
     nxB[nxW + 1];              // index read buffer

int8_t dbErr;  // enum errCode
enum errCode{
  _OK,
  SD_ERR,      // sd error
  DB_EMPTY,    // no record(s) in db
  MAX_REC,     // max records in db
  MAX_CHARS,   // key or data: too many characters
  REC_EXIST,   // record already exists
  NOT_FOUND,   // record not found
  REMOVE_ERR,  // delete file error
  CORRUPT,     // db corrupt
  DIF_NR,      // difference in number of records
  NEW_ERR      // file not erased
};

#endif
