/************************ WiFi Sous-vide *************************
   ESP8266 - Sonoff - Wemos mini - or other ESP8266 module 
   by Ewald Kendziorra sr, 2017 www.kendziorra.nl
   Before you start: read the Sous-vide information in "info.txt"
 *****************************************************************/

#include "SousVidePan.h"

/**  parse quasi-"JSON" in values[] **/
void parse(boolean cls) {
  char *n, *v, *b, c[strlen(wIn) + 1];
  strcpy(c, wIn);
  if (cls) for (uint8_t i = 0; i <= arg3; i++) strcpy(values[i], " "); // clear all values[]
  n = strtok_r(c, "|", &b);
  do {
    v = strtok_r(NULL, "|", &b);
    if (!strlen(v)) strcpy(v, " ");
    strcpy(values[atoi(n)], v);  // fill values[]
  } while (n = strtok_r(NULL, "|", &b));
}

/** get a quasi-"JSON" string from char values[] and send it to ... **/
void out(uint8_t n[], uint8_t l) {
  uint8_t len = 0;
  for (uint8_t i = 0; i < l; i++) len += strlen(values[n[i]]) + 4;  // calc max string length
  char str[len + 2];
  strcpy(str, "|");
  for (uint8_t i = 0; i < l; i++)
    sprintf(str + strlen(str), "%s|%s|", String(n[i]).c_str(), (strlen(values[n[i]]) ? values[n[i]] : " "));
  sendTXT(str);
}

/** to cients **/
void sendTXT(char* str) {
  webSocket.broadcastTXT(str);  // to all
  delay(20);  // short delay to broadcast
}

void sendTime(char *stat, time_t n) {
  char str[60];
  msInfo = now() + timeSteps;
  sprintf(str, "|TIME|%s: %02u:%02u:%02u, temp: %s|", stat, hour(n), minute(n), second(n), String(tempOut(input), 2).c_str());
  sendTXT(str);
}

void sendChart() {
  char str[40];
  sprintf(str, "|CHRT|%s,%s|", String(tempOut(sopids[Sp]), 2).c_str(), String(tempOut(input), 2).c_str());
  sendTXT(str);
}

void webSocketEvent(uint8_t num, WStype_t type, uint8_t * payload, size_t len) {
  switch (type) {
    case WStype_DISCONNECTED: {
      strcpy(connectecNames[num], "");  // clear disconnected client
      break;
    }
    case WStype_CONNECTED: {
      char *p, *b;
      p = strtok_r((char*)payload + 1, "/", &b);
      char n[maxNum];
      strcpy(n, p);  // client name
      p = strtok_r(NULL, "/", &b);
      if ((strcmp(p, publishKey)) != 0) webSocket.disconnect(num);
      else {
        strcpy(connectecNames[num], n);
        strcpy(values[connected], connectecNames[num]);
        uint8_t n[] = {connected};
        out(n, sizeof(n));
      }
      break;
    }
    case WStype_TEXT: { // msg from client #n
      if (payload[0] == 124 && payload[len - 1] == 124)  // 124 is char '|'
        strcpy(messageQueue[messageItems++], (char*)payload);
      break;
    }
  }
}
