/************************ WiFi Sous-vide *************************
   ESP8266 - Sonoff - Wemos mini - or other ESP8266 module 
   by Ewald Kendziorra sr, 2017 www.kendziorra.nl
   Before you start: read the Sous-vide information in "info.txt"
 *****************************************************************/

#ifndef TUNE_H
  #define TUNE_H

  //###############################//
  //# all temperatures in Celsius #//
  //###############################//
  
  void tuneStop();
  void tuneStart();
  void doControl();
  void driveOutput();
  void getTemp();
  
  enum { 
    OFF = 0, 
    ON = 1,
    Sp = 0,  // setpoint
    Os = 1,  // sensor offset
    Kp = 2,
    Ki = 3,
    Kd = 4,
    Ts = 5   // C/F/K scale
  };
  
  const uint8_t pidMs = 15;      // millis cycle time for driveOutput()
  const uint32_t timeMax[2] = {(4320 * 60), (240 * 60)};  // seconds (cooking: max 4320 or 72:00, wait: max 240)
  //                                Sp   Os      Kp    Ki    Kd   Ts  //
  const double sopidDefaults[6] = {60.0, 0.0, 1018.59, 9.32, 0.0, 0.0},  // first use setpoint, Offset, Kp, Ki, Kd, Scale values
               tempMinMax[2] = {35.0, 90.0};  // in *C (min. 35.00/95.00/308.15, max 90.00/194.00/363.15 (C/F/K))
  uint8_t relayLowOrHigh = LOW,
          CFK;  // Celtius, Fahrenheit, or Kelvin
  uint16_t windowSize = 10000;  // n sec. Proportional Output window
  double input = 32,
         output,
  //                   Sp   Os      Kp    Ki    Kd   Ts  //
         sopids[6] = {60.0, 0.0, 1018.59, 9.32, 0.0, 0.0};  // setpoint, sensorOffset, Kp, Ki, Kd, scale values
  time_t windowStartTime = 0,
         pidCycle = millis();

#endif
