/************************* WiFi Sous-vide ************************
   ESP8266 - Sonoff - Wemos mini - or other ESP8266 module 
   by Ewald Kendziorra sr, 2017 www.kendziorra.nl
   Before you start: read the Sous-vide information in "info.txt"
 *****************************************************************/

#include "SousVidePan.h"

void tuneStart() {
  sensors.requestTemperatures(); // Start an asynchronous temperature reading
  myPID.SetMode(AUTOMATIC);  // PID on
  windowStartTime = millis();
}

void tuneStop() {
  if (tuning) {
    aTune.Cancel();
    tuning = false;
  }
  startSet = No;
  cookTmp = false;
  myPID.SetMode(MANUAL);
  digitalWrite(relayPin, LOW);  // make sure it is off
}

/** Execute the control loop **/
void doControl() {
  if (tuning && aTune.Runtime()) finishAutoTune();
  else myPID.Compute();  // Execute control algorithm
}

/** relay ON/OFF **/
void driveOutput() {
  relayLowOrHigh = LOW;
  if(millis() - windowStartTime > windowSize) windowStartTime += windowSize;  //time to shift the Relay Window
  if((output > 100) && (output > (millis() - windowStartTime)) && ((input < (sopids[Sp] + 0.05)) || tuning)) relayLowOrHigh = HIGH;
  digitalWrite(relayPin, relayLowOrHigh);
}

void getTemp() {
  if (sensors.isConversionComplete()) {
    input = sensors.getTempC(tempSensor) + sopids[Os];
    sensors.requestTemperatures(); // for the next time
  }
}

