var socketIP = networkSTA;  // Station mode
var publishQueue = [];  // queue with items to plublish at the end of function commandMsg()
var stopWS = true;  // true: avoid automatic connection
var rbutton = 'rbnSTA';  // holt active radio button

/********** i am **********/
var audio = new Audio();
audio.loop = false;
audioStop;

/********** proceed data **********/
function commandMsg(msg) {  // is used by WebsocketClient.js
  wIn = msg;
  if (!(msg.startsWith('|') && msg.endsWith('|')))  return;

  if (msg.startsWith('|CHRT|')) {
    //                                 temp, setpoint
    // text to chart - commandMsg('|chrt|30,48|');
    addDataToChart(msg.substring(6, msg.length - 1));
   	return;
  }

  if (msg.startsWith('|TIME|')) {  // cls info
  	$('#time').html(msg.substring(6, msg.length - 1).replace(/ /g , '&nbsp;'));
  	return;
  }
  if (msg.startsWith('|INFO|')) {  // cls info
  	$('#info').html(msg.substring(6, msg.length - 1));
 	  $('#info').append('<br>');
  	return;
  }
  if (msg.startsWith('|@|')) {  // append text to info
  	$('#info').append(msg.substring(3, msg.length - 1).replace(/ /g , '&nbsp;'));
 	  $('#info').append('<br>');
 	  return;
  }
  parse();
  $('#respons').html('<br>' + outNames());
  if (values[mp3].length) play(values[mp3]);
  // ##### update ...
  // after update : send next message
  if (typeof publishQueue != 'undefined' && publishQueue.length != 0) 
  publishIt('');
}

/********** dis/connect buttons **********/
$('#btnConnect').click(function() {   // connect to server 
  if (!isConnected) {
    $('#btnConnect').html('<img src=include/conn.png>'); 
    audioStop();
    stopWS = false;
    clearFields();
    init();
  }
  else {
    $('#btnConnect').html('<img src=include/disConn.png>');
    audioStop();
    stopWS = true;
    clearFields();
    websocket.close();
    websocket = null; 
  }
});

/********** commands **********/
$('#btnSend').click(function() {  // send to server
  send();
});

$('#inpCmd').on('keydown', function(evt) {  // on enter send to server
    if(evt.keyCode == 13) send();
}); 

$('#inpArg3').on('keydown', function(evt) {  // on enter send to server
    if(evt.keyCode == 13) send();
}); 

function send() {
  if (!isConnected) {
    $('#respons').text('NOT connected!!!');
    while (publishQueue.length) publishQueue.shift();  // clear Queue
    return;
  }
  clearFields();
  
  if ($('#inpCmd').val() == 'start' || $('#inpCmd').val() == 'auto') clearChart();
  values[client] = clientID;
  values[command] = $('#inpCmd').val();
  values[arg1] =    $('#inpArg1').val();
  values[arg2] =    $('#inpArg2').val();
  values[arg3] =    $('#inpArg3').val();
  var n = [client, command, arg1, arg2, arg3];
  publishIt(out(n, n.length)); 

}

/********** publish **********/
function publishIt(msg) {
  if (msg.length) publishQueue[publishQueue.length] = msg;
  if (publishQueue.length == 1) {  // only one item in Queue?
    if (!isConnected) {clearFields(); return;}  // if 'false' then clear old messages
    publish(publishQueue[0]);  // send message to server
    publishQueue.shift();
  }
}

/********** audio **********/

function audioStop() {
  audio.pause();
//  audio.currentTime = 0;
}
  
function play(s) {
  if (stopWS) return;
  audioStop();
  switch (s) {
    case 'ready':
    case 'insert':
      audio.loop = true;
      break;
    default:  // error, stop
      audio.loop = false;
  }
  audio.src = 'mp3/' + s + '.mp3';
  audio.play();
}

$('#btnSound').click(function() {
  audioStop();
});
  
/********** diverse **********/
function errorMsg(error) {  // show Websocket error
  $('#respons').text('ERROR');
}

function disCon() {  // show connected or disconnected
  if (isConnected)
  		$('#btnConnect').html('<img src=include/conn.png>'); 
  else 
  		$('#btnConnect').html('<img src=include/disConn.png>');
}

function clearFields() {  // clear old messages
  $('#respons').text('');
}
