﻿/************************** Sous-Vide ***************************
 * With Wemos D1 Mini - ESP8266-12E                             * 
 * by Ewald Kendziorra sr, 2016 www.kendziorra.nl               *
 * Before you start: read the Sous-Vide information in "info.h" *
 ****************************************************************/

// JSON: indicate the type of a quasi JSON structure
/***** in ESP8266/JavaScript *****
 * Some code is converted from ESP8266 C/C++ to JavaScript
 * so you have in both languages somewhat similar code and structures for "JSON" string and parse
 *
 * JSON in this project: indicate the type of a simple quasi "JSON" structure (C/C++ has no JSON)
 * example of a quasi "JSON" string:
 * instead a "name" we use a "number" (ENUM) with the corresponding names[enum] and values[enum]
 *   string from ESP8266: '|3|value_0|1|value_1|7|value_2|'
 *            instead of: '{"name_3":"value_0","name_1":"value_1","name_7":"value_2"}'
 * the use of enum reduces the websocket and Serial data traffic significant
 */

/******* numbers as alternative "JSON" names *******/
// not a real enum{}! must correspond with "var names[enum]"
                 // insert or add items on your own risk!!!
                 // =======================================
const client =    0,  // from client (browser(s) or other IoThing client(s))
      Connected = 1,  // client
      command =   2,  // command with optional ..
      arg1 =      3,  // ... one or ...     // for KaKu: used for OLD (1) or NEW (0) KaKu
      arg2 =      4,  // ... two or ...
      arg3 =      5,  // ... three arguments
      message =   6,  // message to client
      mp3 =       7;      // sound: danger, error, insert, ready, shake, stop, beep, stage

const names = [  // must be the same number and order as enum (as above)
// only used for friendly printing: var str = outNames()/outName(n)
  'client',
  'Connected',
  'command',
  'arg1',
  'arg2',
  'arg3',
  'message',
  'mp3'
]; 
/**************/
const eNumLen = mp3 + 1;
const fieldLen = 20;   // max. length value fields = 20
var values = new Array(eNumLen);  // list with parsed values
var wIn;  // websocket inBuf, reserve bytes (IN)buf (estimated average value length of 10)
