﻿/* 
 * Ewald Kendziorra sr, 2015, http://kendziorra.nl
 * License: Free
 * Publishing: Only with this header
 * Editing: Free
 * Guarantee: No
 * Using: At your own risk
 * Support: No
 */
 
var websocket;
var isConnected = false;

/********** is WebSockets alive **********/
$(document).ready(function () {        
    setInterval(openWebSocket, 5000);
});
 
function openWebSocket() {
  if (stopWS) return;  // user stopped the connection 
  if (websocket == null || websocket.readyState == undefined || websocket.readyState != 1) {
    isConnected = false;
    disCon();
  }
}

/********** WEBSOCKET **********/
function init() {
  var wsUri = 'ws://' + socketIP + ':' + socketPort + '/' + clientID + '/' + publishKey;
  websocket = new WebSocket(wsUri, ['arduino']);
  websocket.onopen = function(evt) { onOpen(evt) }; 
  websocket.onclose = function(evt) { onClose(evt) }; 
  websocket.onmessage = function(evt) { onMessage(evt) }; 
  websocket.onerror = function(evt) { onError(evt) }; 
}   

function onOpen(e) {
  isConnected = true;
  disCon();  // in WebsocketNHS.js
}

function onClose(e) {
  isConnected = false;
  disCon();  // in  WebsocketNHS.js
}

function onMessage(e) {
  var str = e.data.replace('\0', '');
  commandMsg(str);  // in WebsocketNHS.js
}

function onError(e)
{
  var str = e.type.replace('\0', '');
  errorMsg(str);  // in WebsocketNHS.js
}

function publish(msg) {
  websocket.send(msg);  // send message to server
}
